"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getRects = exports.getAllElements = exports.addTupleToObject = void 0;

var _utilities = require("../../utilities");

var constants = _interopRequireWildcard(require("../../constants"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var addTupleToObject = function addTupleToObject(acc, curr) {
  return (0, _utilities.assign)(acc, _defineProperty({}, curr[0], curr[1]));
};

exports.addTupleToObject = addTupleToObject;

var getAllElements = function getAllElements(element, portalKey) {
  if (portalKey) {
    return (0, _utilities.toArray)(document.querySelectorAll("[".concat(constants.DATA_PORTAL_KEY, "=\"").concat(portalKey, "\"]")));
  } else {
    return (0, _utilities.toArray)(element.querySelectorAll("[".concat(constants.DATA_FLIP_ID, "]")));
  }
};

exports.getAllElements = getAllElements;

var getRects = function getRects(flippedElements) {
  return flippedElements.map(function (child) {
    return [child, child.getBoundingClientRect()];
  });
};

exports.getRects = getRects;