"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = SwipeWrapper;

var _react = _interopRequireWildcard(require("react"));

var _context = require("../Flipper/context");

var _propTypes = _interopRequireDefault(require("prop-types"));

var _Swipe = _interopRequireDefault(require("../FlipToolkit/Swipe"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var SwipeComponent =
/*#__PURE__*/
function (_Component) {
  _inherits(SwipeComponent, _Component);

  function SwipeComponent() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, SwipeComponent);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(SwipeComponent)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "processProps", function (props) {
      return _objectSpread({}, props, {
        flipId: props.flipId ? String(props.flipId) : String(props.children.props.flipId)
      });
    });

    _defineProperty(_assertThisInitialized(_this), "swipe", new _Swipe.default(_this.processProps(_this.props)));

    return _this;
  }

  _createClass(SwipeComponent, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      this.swipe.props = this.processProps(this.props);
      this.swipe.prevProps = this.processProps(prevProps);
    }
  }, {
    key: "render",
    value: function render() {
      _react.default.Children.only(this.props.children); // @ts-ignore


      if (this.props.children.type.displayName === 'Flipped') {
        return (0, _react.cloneElement)(this.props.children, {
          gestureHandlers: this.swipe.handlers
        });
      }

      return (0, _react.cloneElement)(this.props.children, this.swipe.handlers);
    }
  }]);

  return SwipeComponent;
}(_react.Component);

function SwipeWrapper(props) {
  return _react.default.createElement(_context.GestureContext.Consumer, null, function (p) {
    return (// @ts-ignore
      _react.default.createElement(SwipeComponent, _extends({
        inProgressAnimations: p.inProgressAnimations,
        setIsGestureInitiated: p.setIsGestureInitiated
      }, props))
    );
  });
}

if (false) {
  var configPropTypes = _propTypes.default.oneOfType([_propTypes.default.shape({
    initFlip: _propTypes.default.func,
    cancelFlip: _propTypes.default.func,
    threshold: _propTypes.default.number
  }), _propTypes.default.bool]);

  SwipeWrapper.propTypes = {
    children: _propTypes.default.node.isRequired,
    flipId: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number]),
    touchOnly: _propTypes.default.bool,
    onClick: _propTypes.default.func,
    onUp: _propTypes.default.func,
    onDown: _propTypes.default.func,
    threshold: _propTypes.default.number,
    right: configPropTypes,
    left: configPropTypes,
    top: configPropTypes,
    bottom: configPropTypes
  };
}