"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _flip = _interopRequireDefault(require("./flip"));

var _getFlippedElementPositionsBeforeUpdate = _interopRequireDefault(require("./flip/getFlippedElementPositions/getFlippedElementPositionsBeforeUpdate"));

var _utilities = require("./utilities");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Flipper =
/*#__PURE__*/
function () {
  function Flipper(options) {
    _classCallCheck(this, Flipper);

    _defineProperty(this, "element", void 0);

    _defineProperty(this, "staggerConfig", void 0);

    _defineProperty(this, "applyTransformOrigin", true);

    _defineProperty(this, "handleEnterUpdateDelete", void 0);

    _defineProperty(this, "debug", void 0);

    _defineProperty(this, "spring", void 0);

    _defineProperty(this, "inProgressAnimations", void 0);

    _defineProperty(this, "flipCallbacks", void 0);

    _defineProperty(this, "snapshot", void 0);

    _defineProperty(this, "onComplete", void 0);

    _defineProperty(this, "onStart", void 0);

    (0, _utilities.assign)(this, options);
    this.inProgressAnimations = {};
    this.flipCallbacks = {};
    this.recordBeforeUpdate = this.recordBeforeUpdate.bind(this);
    this.update = this.update.bind(this);
    this.addFlipped = this.addFlipped.bind(this);
    this.addInverted = this.addInverted.bind(this);
  }

  _createClass(Flipper, [{
    key: "recordBeforeUpdate",
    value: function recordBeforeUpdate() {
      this.snapshot = (0, _getFlippedElementPositionsBeforeUpdate.default)({
        element: this.element,
        flipCallbacks: this.flipCallbacks,
        inProgressAnimations: this.inProgressAnimations
      });
    }
  }, {
    key: "update",
    value: function update(prevDecisionData, currentDecisionData) {
      if (this.snapshot) {
        (0, _flip.default)({
          flippedElementPositionsBeforeUpdate: this.snapshot.flippedElementPositions,
          cachedOrderedFlipIds: this.snapshot.cachedOrderedFlipIds,
          containerEl: this.element,
          inProgressAnimations: this.inProgressAnimations,
          flipCallbacks: this.flipCallbacks,
          applyTransformOrigin: this.applyTransformOrigin,
          spring: this.spring,
          debug: this.debug,
          staggerConfig: this.staggerConfig,
          handleEnterUpdateDelete: this.handleEnterUpdateDelete,
          decisionData: {
            previous: prevDecisionData,
            current: currentDecisionData
          },
          onComplete: this.onComplete,
          onStart: this.onStart
        });
        delete this.snapshot;
      }
    }
  }, {
    key: "addFlipped",
    value: function addFlipped(_ref) {
      var element = _ref.element,
          flipId = _ref.flipId,
          opacity = _ref.opacity,
          translate = _ref.translate,
          scale = _ref.scale,
          transformOrigin = _ref.transformOrigin,
          spring = _ref.spring,
          stagger = _ref.stagger,
          onAppear = _ref.onAppear,
          onStart = _ref.onStart,
          onSpringUpdate = _ref.onSpringUpdate,
          onComplete = _ref.onComplete,
          onExit = _ref.onExit,
          shouldFlip = _ref.shouldFlip,
          shouldInvert = _ref.shouldInvert;

      if (!element) {
        throw new Error('no element provided');
      }

      if (!flipId) {
        throw new Error('No flipId provided');
      }

      var flipConfig = {
        scale: scale,
        translate: translate,
        opacity: opacity,
        transformOrigin: transformOrigin,
        spring: spring,
        stagger: stagger
      };

      if (!flipConfig.scale && !flipConfig.translate && !flipConfig.opacity) {
        (0, _utilities.assign)(flipConfig, {
          translate: true,
          scale: true,
          opacity: true
        });
      }

      if (flipId) {
        element.dataset.flipId = String(flipId);
      }

      element.dataset.flipConfig = JSON.stringify(flipConfig); // finally, add callbacks

      this.flipCallbacks[flipId] = {
        shouldFlip: shouldFlip,
        shouldInvert: shouldInvert,
        onAppear: onAppear,
        onStart: onStart,
        onSpringUpdate: onSpringUpdate,
        onComplete: onComplete,
        onExit: onExit
      };
    }
  }, {
    key: "addInverted",
    value: function addInverted(_ref2) {
      var element = _ref2.element,
          parent = _ref2.parent,
          opacity = _ref2.opacity,
          translate = _ref2.translate,
          scale = _ref2.scale,
          transformOrigin = _ref2.transformOrigin;

      if (!element) {
        throw new Error('no element provided');
      }

      if (!parent) {
        throw new Error('parent must be provided');
      }

      var inverseFlipId = parent.dataset.flipId;
      var flipConfig = {
        scale: scale,
        translate: translate,
        opacity: opacity,
        transformOrigin: transformOrigin
      };

      if (!flipConfig.scale && !flipConfig.translate && !flipConfig.opacity) {
        (0, _utilities.assign)(flipConfig, {
          translate: true,
          scale: true,
          opacity: true
        });
      }

      element.dataset.inverseFlipId = inverseFlipId;
      element.dataset.flipConfig = JSON.stringify(flipConfig);
    }
  }]);

  return Flipper;
}();

var _default = Flipper;
exports.default = _default;