"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.assign = assign;
exports.tweenProp = exports.getDuplicateValsAsStrings = exports.toArray = exports.isObject = exports.isFunction = exports.isNumber = void 0;

var isNumber = function isNumber(x) {
  return typeof x === 'number';
};

exports.isNumber = isNumber;

var isFunction = function isFunction(x) {
  return typeof x === 'function';
};

exports.isFunction = isFunction;

var isObject = function isObject(x) {
  return Object.prototype.toString.call(x) === '[object Object]';
};

exports.isObject = isObject;

var toArray = function toArray(arrayLike) {
  return Array.prototype.slice.apply(arrayLike);
};

exports.toArray = toArray;

var getDuplicateValsAsStrings = function getDuplicateValsAsStrings(arr) {
  var baseObj = {};
  var obj = arr.reduce(function (acc, curr) {
    acc[curr] = (acc[curr] || 0) + 1;
    return acc;
  }, baseObj);
  return Object.keys(obj).filter(function (val) {
    return obj[val] > 1;
  });
}; // tslint only likes this with a regular function, not an arrow function


exports.getDuplicateValsAsStrings = getDuplicateValsAsStrings;

function assign(target) {
  for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    args[_key - 1] = arguments[_key];
  }

  args.forEach(function (arg) {
    if (!arg) {
      return;
    } // Skip over if undefined or null


    for (var nextKey in arg) {
      // Avoid bugs when hasOwnProperty is shadowed
      if (Object.prototype.hasOwnProperty.call(arg, nextKey)) {
        target[nextKey] = arg[nextKey];
      }
    }
  });
  return target;
}

var tweenProp = function tweenProp(start, end, position) {
  return start + (end - start) * position;
};

exports.tweenProp = tweenProp;