"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _FlipToolkit = require("../FlipToolkit");

var _context = require("./context");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Flipper =
/*#__PURE__*/
function (_Component) {
  _inherits(Flipper, _Component);

  function Flipper() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, Flipper);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(Flipper)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "isGestureControlled", false);

    _defineProperty(_assertThisInitialized(_this), "isGestureInitiated", false);

    _defineProperty(_assertThisInitialized(_this), "inProgressAnimations", {});

    _defineProperty(_assertThisInitialized(_this), "flipCallbacks", {});

    _defineProperty(_assertThisInitialized(_this), "el", undefined);

    _defineProperty(_assertThisInitialized(_this), "setIsGestureInitiated", function () {
      _this.isGestureInitiated = true;
    });

    return _this;
  }

  _createClass(Flipper, [{
    key: "getSnapshotBeforeUpdate",
    value: function getSnapshotBeforeUpdate(prevProps) {
      // a roundabout method to fix issues with gesture ==> nongesture cancellations
      if (this.isGestureInitiated) {
        this.isGestureControlled = true;
        this.isGestureInitiated = false;
      } else {
        this.isGestureControlled = false;
      }

      if (prevProps.flipKey !== this.props.flipKey && this.el) {
        return (0, _FlipToolkit.getFlippedElementPositionsBeforeUpdate)({
          element: this.el,
          // if onExit callbacks exist here, we'll cache the DOM node
          flipCallbacks: this.flipCallbacks,
          inProgressAnimations: this.inProgressAnimations,
          portalKey: this.props.portalKey
        });
      }

      return null;
    }
  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, _prevState, cachedData) {
      if (this.props.flipKey !== prevProps.flipKey && this.el) {
        (0, _FlipToolkit.onFlipKeyUpdate)({
          flippedElementPositionsBeforeUpdate: cachedData.flippedElementPositions,
          cachedOrderedFlipIds: cachedData.cachedOrderedFlipIds,
          isGestureControlled: this.isGestureControlled,
          containerEl: this.el,
          inProgressAnimations: this.inProgressAnimations,
          flipCallbacks: this.flipCallbacks,
          applyTransformOrigin: this.props.applyTransformOrigin,
          spring: this.props.spring,
          debug: this.props.debug,
          portalKey: this.props.portalKey,
          staggerConfig: this.props.staggerConfig,
          handleEnterUpdateDelete: this.props.handleEnterUpdateDelete,
          decisionData: {
            previous: prevProps.decisionData,
            current: this.props.decisionData
          },
          onComplete: this.props.onComplete,
          onStart: this.props.onStart
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          element = _this$props.element,
          className = _this$props.className,
          portalKey = _this$props.portalKey;
      var Element = element;

      var flipperMarkup = _react.default.createElement(_context.GestureContext.Provider, {
        value: {
          inProgressAnimations: this.inProgressAnimations,
          setIsGestureInitiated: this.setIsGestureInitiated
        }
      }, _react.default.createElement(_context.FlipContext.Provider, {
        value: this.flipCallbacks
      }, _react.default.createElement(Element, {
        className: className,
        ref: function ref(el) {
          return _this2.el = el;
        }
      }, this.props.children)));

      if (portalKey) {
        flipperMarkup = _react.default.createElement(_context.PortalContext.Provider, {
          value: portalKey
        }, flipperMarkup);
      }

      return flipperMarkup;
    }
  }]);

  return Flipper;
}(_react.Component); // @ts-ignore


_defineProperty(Flipper, "defaultProps", {
  applyTransformOrigin: true,
  element: 'div'
});

if (false) {
  // @ts-ignore
  Flipper.propTypes = {
    flipKey: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.number, _propTypes.default.bool]).isRequired,
    children: _propTypes.default.node.isRequired,
    spring: _propTypes.default.oneOfType([_propTypes.default.string, _propTypes.default.object]),
    applyTransformOrigin: _propTypes.default.bool,
    debug: _propTypes.default.bool,
    element: _propTypes.default.string,
    className: _propTypes.default.string,
    portalKey: _propTypes.default.string,
    staggerConfig: _propTypes.default.object,
    decisionData: _propTypes.default.any,
    handleEnterUpdateDelete: _propTypes.default.func,
    onComplete: _propTypes.default.func,
    isGestureControlled: _propTypes.default.bool,
    onStart: _propTypes.default.func
  };
}

var _default = Flipper;
exports.default = _default;